;
; generic
;

(define addcelllst (lambda (lst n k f g)
    (cond
;	 ((null? lst) '())	; I don't think this happens anymore
	 ((null? (cdr lst)) '(0))
	 (else (cons (+ (* (apply f `(,n ,k)) (car lst))
			(* (apply g `(,n ,k)) (cadr lst)))
		     (addcelllst (cdr lst) n (+ k 1) f g))))))

(define nextcellnum (lambda (lst n f g) (cons 0 (addcelllst lst n 1 f g))))

(define cell ())

(let ((bar '(1 0))
      (f (lambda (n k) 1))
      (g (lambda (n k) 1))
      (n 1))
      (set! cell (lambda lll
	(cond
	  ((null? lll)
	    (begin
	     (set! bar (nextcellnum bar n f g))
             (set! n (+ n 1))
	     (reverse (cdr (reverse (cdr bar))))))		; ick
	  (else
	    (begin
	     (set! n 1)
	     (set! bar '(1 0))
	     (set! f (car lll))
	     (set! g (cadr lll))
	     (if (= (length lll) 3) (set! n (caddr lll))) ))))))

;
; and now some stuff to go with that..
;

(define bin-init (lambda () (cell	; binomials
				(lambda (n k) 1)
				(lambda (n k) 1))))

(define s1-init (lambda () (cell	; Stirling numbers, first kind
				(lambda (n k) 1)
				(lambda (n k) (- 1 n)))))

(define s2-init (lambda () (cell	; Stirling numbers, second kind
				(lambda (n k) 1)
				(lambda (n k) k))))

(define ean-init (lambda () (cell	; Eulerian numbers
				(lambda (n k) (+ 1 (- n k)))
				(lambda (n k) k))))

;
; dumb girlfriend numbers
;

(define sf1n-init (lambda () (cell	; dg numbers, 1st kind n
				(lambda (n k) 1)
				(lambda (n k) (- 1 (expt n 2))))))

(define sf1k-init (lambda () (cell	; dg numbers, 1st kind k
				(lambda (n k) 1)
				(lambda (n k) (- 1 (expt (+ k 1) 2))))))
; ; ; ;

(define sf2n-init (lambda () (cell	; dg, 2nd kind n
				(lambda (n k) 1)
				(lambda (n k) (+ (* (- n 1) (- n 2)) 1)))))

(define sf2k-init (lambda () (cell	; dg, 2nd kind k
				(lambda (n k) 1)
				(lambda (n k) (+ (* k (- k 1)) 1)))))

; ; ; ;

(define sf3n-init (lambda () (cell	; dg, 3rd kind n
				(lambda (n k) 1)
				(lambda (n k) (- 1 (expt n 3))))))

(define sf3k-init (lambda () (cell	; dg, 3rd kind k
				(lambda (n k) 1)
				(lambda (n k) (- 1 (expt (+ k 1) 3))))))

; ; ; ;

(define perm5-1n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 3) (1 2) (2 1) (3 4) (4 5))))))))

(define perm5-1k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 3) (0 2) (1 1) (2 4) (3 5))))))))

; ; ; ;

(define perm5-2n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 1) (1 3) (2 4) (3 2) (4 5))))))))

(define perm5-2k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 1) (0 3) (1 4) (2 2) (3 5))))))))

; ; ; ;

(define perm5-3n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 2) (1 4) (2 3) (3 1) (4 5))))))))

(define perm5-3k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 2) (0 4) (1 3) (2 1) (3 5))))))))

; ; ; ;

(define perm5-4n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 5) (1 2) (2 3) (3 1) (4 4))))))))

(define perm5-4k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 5) (0 2) (1 3) (2 1) (3 4))))))))

; ; ; ;

(define perm5-5n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 5) (1 3) (2 4) (3 1) (4 2))))))))

(define perm5-5k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 5) (0 3) (1 4) (2 1) (3 2))))))))

; ; ; ;

(define perm5-6n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 2) (1 3) (2 4) (3 5) (4 1))))))))

(define perm5-6k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 2) (0 3) (1 4) (2 5) (3 1))))))))

; ; ; ;

(define perm5-7n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 1) (1 2) (2 4) (3 5) (4 3))))))))

(define perm5-7k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 1) (0 2) (1 4) (2 5) (3 3))))))))

; ; ; ;

(define perm5-8n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 1) (1 5) (2 4) (3 2) (4 3))))))))

(define perm5-8k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 1) (0 5) (1 4) (2 2) (3 3))))))))
; ; ; ;

(define perm5-9n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 5)
				      '((0 1) (1 4) (2 5) (3 2) (4 3))))))))

(define perm5-9k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 5)
				      '((4 1) (0 4) (1 5) (2 2) (3 3))))))))

; ; ; ;

(define perm7-1n-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo n 7)
				      '((0 1) (1 2)
					(2 7) (3 4)
					(4 3) (5 6)
					(6 5) )))))))

(define perm7-1k-init (lambda () (cell	; permutation
				(lambda (n k) 1)
				(lambda (n k) (cadr (assoc (modulo k 7)
				      '((6 1) (0 2)
					(1 7) (2 4)
					(3 3) (4 6)
					(5 5) )))))))

;
; end of dg numbers
;

(define my-init (lambda () (cell	; my numbers
				(lambda (n k) 1)
				(lambda (n k) (* k n)))))

;
;
;

;
; blah..
;

(define pwrmod (lambda (num n k)
    (cond 
      ((= (modulo num (expt n k) ) 0) (+ 1 (pwrmod num n (+ 1 k))))
      (else 0))))

(define pmod (lambda (num n) (pwrmod (abs num) n 1)))

;
; XXX - modulo broken with big negative numbers!?
;

(define powlstcvt (lambda (lst num)
    (if (null? lst) ()
	  (cons (pmod (car lst) num) (powlstcvt (cdr lst) num)))))

; XXXXXXXXXXXXXXXXXX this fucking bug still hasn't gone away!

(define modudork (lambda (num div)
    (let ((foo (modulo num div)))
	(if (= foo div) 0 foo))))

; (define modlstcvt (lambda (lst num)
;     (if (null? lst) ()
; 	  (cons (modudork (car lst) num) (modlstcvt (cdr lst) num)))))

(define modlstcvt (lambda (lst num)
    (if (null? lst) ()
	  (cons (modulo (car lst) num) (modlstcvt (cdr lst) num)))))

(define umodlstcvt (lambda (lst num)
    (if (null? lst) ()
	  (cons (modulo (abs (car lst)) num) (umodlstcvt (cdr lst) num)))))

;
;
; XXX - watch it if this doesn't work with the big negs
;

(define repeat (lambda args
    (do ((bar 1 (+ bar 1))) ((< (car args) bar) )
    (apply (cadr args) (cddr args)))))

; for a nice demo, try:
; (repeat 15 (lambda () (begin (display (powlstcvt (cell) 3)) (newline))))

(define rep-list (lambda (r)
 (repeat r (lambda () (begin (display (cell)) (newline))))))

(define rep-plist (lambda (r n)
 (repeat r (lambda () (begin (display (powlstcvt (cell) n)) (newline))))))

(define rep-mlist (lambda (r n)
 (repeat r (lambda () (begin (display (modlstcvt (cell) n)) (newline))))))

(define rep-umlist (lambda (r n)
 (repeat r (lambda () (begin (display (umodlstcvt (cell) n)) (newline))))))

